                                                                                                                              {
ͻ
 Turbo Pascal Compiler                                                                                                   
                                                                                                                         
 TPC32 Version 1.0, 32-bit command line compiler compatible with Borland Turbo Pascal 7 TPC.EXE                          
                                                                                                                         
 Copyright (C) 2000,2010 Igor Funa                                                                                       
                                                                                                                         
͹
 TPC32                                                                                                                   
͹
                                                                                                                         
 Turbo Pascal Compiler (32-bit) - Compatible with Borland Turbo Pascal 7 command line compiler TPC.EXE                   
                                                                                                                         
 TPC32 still generates 16-bit code                                                                                       
                                                                                                                         
ͼ  }

{$APPTYPE CONSOLE}

Program TPC32;

Uses SysUtils,
     Windows,
     Parser,
     Scanner,
     IOUtilities,
     CommonVariables;

begin
  Writeln (GreetingString);
{$WARNINGS OFF}
  CommandLinePtr := CmdLine;
{$WARNINGS ON}
  ReadConfigurationFile;
  CompilerModeOptions := [cmoCreateExeFile, cmoCompileToDisk];
  LinkerOptions := [];
  StartOfSourceFilesData := @SourceFilesBuffer;
  ProcessCompilerParameters;
  StrCopy (TempString, DefaultModuleData.LibraryName);
  CurrentFileName := TempString;
  FindFilePath (TempString, fd_TPL_CFG, feOriginal, []);
  SaveRegistersAndSetErrorReturnAddress;
  LoadLibrary;
  Case LastError of
    FileNotFound: Writeln ('Warning: ', TempString, ' not found.');
    NoError:
    else WriteCompilationErrorAndHalt;
  end;
  With DefaultModuleData do
    begin
      InitialEnvironmentFlags := EnvironmentFlags;
      InitialCompilerSwitches := CompilerSwitches;
      ModuleStack   := Stack;
      ModuleHeapMin := HeapMin;
      ModuleHeapMax := HeapMax;
    end;
  CurrentFileName := MainFileName;
  FindFilePath (CurrentFileName, fdCurrentDirectory, fe_PAS, []);
  StartTime := Time;
  CompilationInProgress := True;
  SaveRegistersAndSetErrorReturnAddress;
  Compile;
  CompilationInProgress := False;
  StopTime := Time;
  If LastError <> NoError then WriteCompilationErrorAndHalt;
  If cmoFindError in CompilerModeOptions then
    begin
      SaveRegistersAndSetErrorReturnAddress;
      FindAndWriteSourceLine;
      WriteCompilationErrorAndHalt;
    end;
  WriteCompilationStatus;
end.
